# swagger-client
Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 5.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen
For more information, please visit [https://developer.ingrammicro.com/contact](https://developer.ingrammicro.com/contact)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.QuotesApi(swagger_client.ApiClient(configuration))
quote_number = 'quote_number_example' # str | Ingram Micro Quote Number
customer_number = '20-222222' # str | Your Ingram Micro unique customer number (default to 20-222222)
iso_country_code = 'US' # str |  (default to US)
third_party_source = 'customer' # str | Unique identifier used to identify the third party source accessing the services (optional) (default to customer)

try:
    # Get quote details
    api_response = api_instance.get_v5_quotes_details(quote_number, customer_number, iso_country_code, third_party_source=third_party_source)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling QuotesApi->get_v5_quotes_details: %s\n" % e)

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.QuotesApi(swagger_client.ApiClient(configuration))
body = swagger_client.QuoteListRequest() # QuoteListRequest |  (optional)

try:
    # Search quotes
    api_response = api_instance.post_v5_quotes_search(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling QuotesApi->post_v5_quotes_search: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*QuotesApi* | [**get_v5_quotes_details**](docs/QuotesApi.md#get_v5_quotes_details) | **GET** /quotes/{quoteNumber} | Get quote details
*QuotesApi* | [**post_v5_quotes_search**](docs/QuotesApi.md#post_v5_quotes_search) | **POST** /quotes/search | Search quotes

## Documentation For Models

 - [QuoteDetails](docs/QuoteDetails.md)
 - [QuoteDetailsQuoteDetailResponse](docs/QuoteDetailsQuoteDetailResponse.md)
 - [QuoteDetailsQuoteDetailResponseResponsePreamble](docs/QuoteDetailsQuoteDetailResponseResponsePreamble.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponse.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseAccountInfo.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseContactInfo.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseEndUser.md)
 - [QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes](docs/QuoteDetailsQuoteDetailResponseRetrieveQuoteResponseVendorAttributes.md)
 - [QuoteDetailsRequest](docs/QuoteDetailsRequest.md)
 - [QuoteDetailsRequestQuoteProductsRequest](docs/QuoteDetailsRequestQuoteProductsRequest.md)
 - [QuoteDetailsRequestQuoteProductsRequestRequestpreamble](docs/QuoteDetailsRequestQuoteProductsRequestRequestpreamble.md)
 - [QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest](docs/QuoteDetailsRequestQuoteProductsRequestRetrieveQuoteProductsRequest.md)
 - [QuoteListRequest](docs/QuoteListRequest.md)
 - [QuoteListRequestQuoteSearchRequest](docs/QuoteListRequestQuoteSearchRequest.md)
 - [QuoteListRequestQuoteSearchRequestRequestPreamble](docs/QuoteListRequestQuoteSearchRequestRequestPreamble.md)
 - [QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest](docs/QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.md)
 - [QuoteListResponse](docs/QuoteListResponse.md)
 - [QuoteListResponseQuoteSearchResponse](docs/QuoteListResponseQuoteSearchResponse.md)
 - [QuoteListResponseQuoteSearchResponseQuoteList](docs/QuoteListResponseQuoteSearchResponseQuoteList.md)
 - [QuoteListResponseQuoteSearchResponseResponsePreamble](docs/QuoteListResponseQuoteSearchResponseResponsePreamble.md)
 - [QuoteProductList](docs/QuoteProductList.md)
 - [QuoteProductListPrice](docs/QuoteProductListPrice.md)

## Documentation For Authorization


## application

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - ****: 


## Author


