# swagger_client.QuotesApi

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_v5_quotes_details**](QuotesApi.md#get_v5_quotes_details) | **GET** /quotes/{quoteNumber} | Get quote details
[**post_v5_quotes_search**](QuotesApi.md#post_v5_quotes_search) | **POST** /quotes/search | Search quotes

# **get_v5_quotes_details**
> QuoteDetails get_v5_quotes_details(quote_number, customer_number, iso_country_code, third_party_source=third_party_source)

Get quote details

The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.QuotesApi(swagger_client.ApiClient(configuration))
quote_number = 'quote_number_example' # str | Ingram Micro Quote Number
customer_number = '20-222222' # str | Your Ingram Micro unique customer number (default to 20-222222)
iso_country_code = 'US' # str |  (default to US)
third_party_source = 'customer' # str | Unique identifier used to identify the third party source accessing the services (optional) (default to customer)

try:
    # Get quote details
    api_response = api_instance.get_v5_quotes_details(quote_number, customer_number, iso_country_code, third_party_source=third_party_source)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling QuotesApi->get_v5_quotes_details: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **quote_number** | **str**| Ingram Micro Quote Number | 
 **customer_number** | **str**| Your Ingram Micro unique customer number | [default to 20-222222]
 **iso_country_code** | **str**|  | [default to US]
 **third_party_source** | **str**| Unique identifier used to identify the third party source accessing the services | [optional] [default to customer]

### Return type

[**QuoteDetails**](QuoteDetails.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **post_v5_quotes_search**
> QuoteListResponse post_v5_quotes_search(body=body)

Search quotes

The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro's CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API. 

### Example
```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.QuotesApi(swagger_client.ApiClient(configuration))
body = swagger_client.QuoteListRequest() # QuoteListRequest |  (optional)

try:
    # Search quotes
    api_response = api_instance.post_v5_quotes_search(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling QuotesApi->post_v5_quotes_search: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**QuoteListRequest**](QuoteListRequest.md)|  | [optional] 

### Return type

[**QuoteListResponse**](QuoteListResponse.md)

### Authorization

[application](../README.md#application)

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

