# coding: utf-8

"""
    Quote Management APIs

    Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*  # noqa: E501

    OpenAPI spec version: 5.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class QuotesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_v5_quotes_details(self, quote_number, customer_number, iso_country_code, **kwargs):  # noqa: E501
        """Get quote details  # noqa: E501

        The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_v5_quotes_details(quote_number, customer_number, iso_country_code, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str quote_number: Ingram Micro Quote Number (required)
        :param str customer_number: Your Ingram Micro unique customer number (required)
        :param str iso_country_code: (required)
        :param str third_party_source: Unique identifier used to identify the third party source accessing the services
        :return: QuoteDetails
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_v5_quotes_details_with_http_info(quote_number, customer_number, iso_country_code, **kwargs)  # noqa: E501
        else:
            (data) = self.get_v5_quotes_details_with_http_info(quote_number, customer_number, iso_country_code, **kwargs)  # noqa: E501
            return data

    def get_v5_quotes_details_with_http_info(self, quote_number, customer_number, iso_country_code, **kwargs):  # noqa: E501
        """Get quote details  # noqa: E501

        The quote detail API will provide all quote details associated with the quote number provided in the call.  *NOTE: quoteNumber, isoCountryCode and customerNumber is mandatory.*  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_v5_quotes_details_with_http_info(quote_number, customer_number, iso_country_code, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str quote_number: Ingram Micro Quote Number (required)
        :param str customer_number: Your Ingram Micro unique customer number (required)
        :param str iso_country_code: (required)
        :param str third_party_source: Unique identifier used to identify the third party source accessing the services
        :return: QuoteDetails
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['quote_number', 'customer_number', 'iso_country_code', 'third_party_source']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_v5_quotes_details" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'quote_number' is set
        if ('quote_number' not in params or
                params['quote_number'] is None):
            raise ValueError("Missing the required parameter `quote_number` when calling `get_v5_quotes_details`")  # noqa: E501
        # verify the required parameter 'customer_number' is set
        if ('customer_number' not in params or
                params['customer_number'] is None):
            raise ValueError("Missing the required parameter `customer_number` when calling `get_v5_quotes_details`")  # noqa: E501
        # verify the required parameter 'iso_country_code' is set
        if ('iso_country_code' not in params or
                params['iso_country_code'] is None):
            raise ValueError("Missing the required parameter `iso_country_code` when calling `get_v5_quotes_details`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'quote_number' in params:
            path_params['quoteNumber'] = params['quote_number']  # noqa: E501

        query_params = []
        if 'customer_number' in params:
            query_params.append(('customerNumber', params['customer_number']))  # noqa: E501
        if 'iso_country_code' in params:
            query_params.append(('isoCountryCode', params['iso_country_code']))  # noqa: E501
        if 'third_party_source' in params:
            query_params.append(('thirdPartySource', params['third_party_source']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['application']  # noqa: E501

        return self.api_client.call_api(
            '/quotes/{quoteNumber}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='QuoteDetails',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_v5_quotes_search(self, **kwargs):  # noqa: E501
        """Search quotes  # noqa: E501

        The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro's CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_v5_quotes_search(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param QuoteListRequest body:
        :return: QuoteListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_v5_quotes_search_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.post_v5_quotes_search_with_http_info(**kwargs)  # noqa: E501
            return data

    def post_v5_quotes_search_with_http_info(self, **kwargs):  # noqa: E501
        """Search quotes  # noqa: E501

        The endpoint, by default, will retrieve quotes modified or created within the last 30 days Quotes older than 365 days are excluded by default. The date filters enable the retrieval of quotes older than 30 days and up to 365 days when using date range criteria.  The endpoint enables the retrieval and filtering of relevant quote list key criteria data such as Quote Number, Special Bid Numbers, End User Name, Quote Status, and Date Ranges from Ingram Micro's CRM system. Only Active quotes are avaiable through the API. Draft and Closed quotes are excluded and are not accessable through the this API.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_v5_quotes_search_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param QuoteListRequest body:
        :return: QuoteListResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_v5_quotes_search" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['application']  # noqa: E501

        return self.api_client.call_api(
            '/quotes/search', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='QuoteListResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
