# coding: utf-8

"""
    Quote Management APIs

    Ingram Micro quote management API for reading quotes.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*  # noqa: E501

    OpenAPI spec version: 5.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'quote_number': 'str',
        'bid_number': 'str',
        'end_user_name': 'str',
        'from_date': 'date',
        'to_date': 'date',
        'page_index': 'str',
        'records_per_page': 'str',
        'sorting': 'str',
        'sorting_column_name': 'str',
        'third_party_source': 'str'
    }

    attribute_map = {
        'quote_number': 'quoteNumber',
        'bid_number': 'bidNumber',
        'end_user_name': 'endUserName',
        'from_date': 'fromDate',
        'to_date': 'toDate',
        'page_index': 'pageIndex',
        'records_per_page': 'recordsPerPage',
        'sorting': 'sorting',
        'sorting_column_name': 'sortingColumnName',
        'third_party_source': 'thirdPartySource'
    }

    def __init__(self, quote_number=None, bid_number=None, end_user_name=None, from_date=None, to_date=None, page_index=None, records_per_page=None, sorting=None, sorting_column_name=None, third_party_source=None):  # noqa: E501
        """QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest - a model defined in Swagger"""  # noqa: E501
        self._quote_number = None
        self._bid_number = None
        self._end_user_name = None
        self._from_date = None
        self._to_date = None
        self._page_index = None
        self._records_per_page = None
        self._sorting = None
        self._sorting_column_name = None
        self._third_party_source = None
        self.discriminator = None
        if quote_number is not None:
            self.quote_number = quote_number
        if bid_number is not None:
            self.bid_number = bid_number
        if end_user_name is not None:
            self.end_user_name = end_user_name
        if from_date is not None:
            self.from_date = from_date
        if to_date is not None:
            self.to_date = to_date
        if page_index is not None:
            self.page_index = page_index
        if records_per_page is not None:
            self.records_per_page = records_per_page
        if sorting is not None:
            self.sorting = sorting
        if sorting_column_name is not None:
            self.sorting_column_name = sorting_column_name
        if third_party_source is not None:
            self.third_party_source = third_party_source

    @property
    def quote_number(self):
        """Gets the quote_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Unique identifier generated by Ingram Micro's CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.  # noqa: E501

        :return: The quote_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._quote_number

    @quote_number.setter
    def quote_number(self, quote_number):
        """Sets the quote_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Unique identifier generated by Ingram Micro's CRM specific to each quote. When applying a filter to the quoteNumber and including a partial quote number in the filter, all quotes containing any information included in the filter can be retrieved as a subset of all available customer quotes.  # noqa: E501

        :param quote_number: The quote_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """

        self._quote_number = quote_number

    @property
    def bid_number(self):
        """Gets the bid_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Special Pricing Bid Number, also referred to as a Dart Number by some vendors, is a unique identifier associated with vendor specific products and discounts.  # noqa: E501

        :return: The bid_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._bid_number

    @bid_number.setter
    def bid_number(self, bid_number):
        """Sets the bid_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Special Pricing Bid Number, also referred to as a Dart Number by some vendors, is a unique identifier associated with vendor specific products and discounts.  # noqa: E501

        :param bid_number: The bid_number of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """

        self._bid_number = bid_number

    @property
    def end_user_name(self):
        """Gets the end_user_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        End User Name is the end customer name that is associated with a quote in Ingram Micro's CRM  # noqa: E501

        :return: The end_user_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._end_user_name

    @end_user_name.setter
    def end_user_name(self, end_user_name):
        """Sets the end_user_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        End User Name is the end customer name that is associated with a quote in Ingram Micro's CRM  # noqa: E501

        :param end_user_name: The end_user_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """

        self._end_user_name = end_user_name

    @property
    def from_date(self):
        """Gets the from_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Filter to select the beginning date of a desired date range. The default filter is set to the date the user is logged-in to request quotes. Date format: YYYY-MM-DD - An incorrect date input will result in a message \"Date must be entered as YYYY-MM-DD\"  # noqa: E501

        :return: The from_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: date
        """
        return self._from_date

    @from_date.setter
    def from_date(self, from_date):
        """Sets the from_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Filter to select the beginning date of a desired date range. The default filter is set to the date the user is logged-in to request quotes. Date format: YYYY-MM-DD - An incorrect date input will result in a message \"Date must be entered as YYYY-MM-DD\"  # noqa: E501

        :param from_date: The from_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: date
        """

        self._from_date = from_date

    @property
    def to_date(self):
        """Gets the to_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Filter to select the end date of a desired date range. The default number of days to request is the previous 30 days from the date user has logged in. Date format: YYYY-MM-DD - An incorrect date input will result in a message \"Date must be entered as YYYY-MM-DD\"  # noqa: E501

        :return: The to_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: date
        """
        return self._to_date

    @to_date.setter
    def to_date(self, to_date):
        """Sets the to_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Filter to select the end date of a desired date range. The default number of days to request is the previous 30 days from the date user has logged in. Date format: YYYY-MM-DD - An incorrect date input will result in a message \"Date must be entered as YYYY-MM-DD\"  # noqa: E501

        :param to_date: The to_date of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: date
        """

        self._to_date = to_date

    @property
    def page_index(self):
        """Gets the page_index of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Page index or page number for the list of quotes being returned. When less than 25 quotes are returned, the page number will be \"1\". In cases where more than 25 quotes are returned, and the default quotes per page are 25 (see recordPerPage), then the list will continue on subsequent pages.  # noqa: E501

        :return: The page_index of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._page_index

    @page_index.setter
    def page_index(self, page_index):
        """Sets the page_index of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Page index or page number for the list of quotes being returned. When less than 25 quotes are returned, the page number will be \"1\". In cases where more than 25 quotes are returned, and the default quotes per page are 25 (see recordPerPage), then the list will continue on subsequent pages.  # noqa: E501

        :param page_index: The page_index of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """

        self._page_index = page_index

    @property
    def records_per_page(self):
        """Gets the records_per_page of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Number of records (quotes) to display per page in the quote list. The default is 25, but may be increased using the filter by up to 100 records per page. If more than 100 records are requested a message will be returned \"The number of records requested exceeds the 100 record limit.\"   # noqa: E501

        :return: The records_per_page of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._records_per_page

    @records_per_page.setter
    def records_per_page(self, records_per_page):
        """Sets the records_per_page of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Number of records (quotes) to display per page in the quote list. The default is 25, but may be increased using the filter by up to 100 records per page. If more than 100 records are requested a message will be returned \"The number of records requested exceeds the 100 record limit.\"   # noqa: E501

        :param records_per_page: The records_per_page of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """

        self._records_per_page = records_per_page

    @property
    def sorting(self):
        """Gets the sorting of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Sort applies to the selected column (sortingColumnName) and may be specified in Ascending (asc) or Descending (desc) order. The default sort is Descending (desc) - most recent first.  # noqa: E501

        :return: The sorting of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._sorting

    @sorting.setter
    def sorting(self, sorting):
        """Sets the sorting of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Sort applies to the selected column (sortingColumnName) and may be specified in Ascending (asc) or Descending (desc) order. The default sort is Descending (desc) - most recent first.  # noqa: E501

        :param sorting: The sorting of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["asc", "desc"]  # noqa: E501
        if sorting not in allowed_values:
            raise ValueError(
                "Invalid value for `sorting` ({0}), must be one of {1}"  # noqa: E501
                .format(sorting, allowed_values)
            )

        self._sorting = sorting

    @property
    def sorting_column_name(self):
        """Gets the sorting_column_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Refers to the column selected to apply the sorting criteria. The default column is dateCreated and will sort by the most recently created quote first with the following in descending order. The default filter retrieves quotes created within the last 30 days. Filtering allows user to select a specific column to sort: quoteNumber, createdDate, lastModifiedDate, expiryDate, and endUserName.  # noqa: E501

        :return: The sorting_column_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._sorting_column_name

    @sorting_column_name.setter
    def sorting_column_name(self, sorting_column_name):
        """Sets the sorting_column_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Refers to the column selected to apply the sorting criteria. The default column is dateCreated and will sort by the most recently created quote first with the following in descending order. The default filter retrieves quotes created within the last 30 days. Filtering allows user to select a specific column to sort: quoteNumber, createdDate, lastModifiedDate, expiryDate, and endUserName.  # noqa: E501

        :param sorting_column_name: The sorting_column_name of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """

        self._sorting_column_name = sorting_column_name

    @property
    def third_party_source(self):
        """Gets the third_party_source of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501

        Unique identifier used to identify the third party source accessing the services.  # noqa: E501

        :return: The third_party_source of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :rtype: str
        """
        return self._third_party_source

    @third_party_source.setter
    def third_party_source(self, third_party_source):
        """Sets the third_party_source of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.

        Unique identifier used to identify the third party source accessing the services.  # noqa: E501

        :param third_party_source: The third_party_source of this QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest.  # noqa: E501
        :type: str
        """

        self._third_party_source = third_party_source

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QuoteListRequestQuoteSearchRequestRetrieveQuoteRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
